Dim EntityDic
Dim Count

function createLine(StartPoint,EndPoint)

	Dim LineObj As AcadLine
	Set LineObj=ThisDrawing.ModelSpace.AddLine(StartPoint,EndPoint)
	Set createLine=LineObj

End function

function createArc(CenterPoint,StartAngle,EndAngle,Radius,Matrix)

	Dim ArcObj As AcadArc
	Set ArcObj=ThisDrawing.ModelSpace.AddArc(CenterPoint,Radius,StartAngle,EndAngle)
	ArcObj.TransformBy(Matrix)
	Set createArc=ArcObj

End function

function createCircle(CenterPoint,Radius,Matrix)

	Dim CircleObj As AcadCircle
	Set CircleObj=ThisDrawing.ModelSpace.AddCircle(CenterPoint,Radius)
	CircleObj.TransformBy(Matrix)
	Set createCircle=CircleObj

End function

function createProfile(Part As Object,Util As Object,SketchPlane As Object,Instance As Object) As Object

	ReDim Sels(0 To EntityDic.Count-1)
	For I=0 To EntityDic.Count-1

		Set Entity=EntityDic.Item(cstr(I))
		Set Sels(I)=Entity

	Next
	Dim Descrip2D As Object
	Set Descrip2D = Util.CreateSketchDescriptor(2)
	Descrip2D.SketchPlane=SketchPlane
	Descrip2D.ScopeObject=Instance
	Descrip2D.InferConstraints=True
	Descrip2D.Selections=Sels
	On Error Resume Next
	Set CreateProfile=Part.AddSketch(descrip2D)
	If (Err.Number <> 0) Then
		Err.Clear
		ThisDrawing.SendCommand "AMSKMODE" & vbCr & "1" & vbCr
		Set CreateProfile = Part.AddSketch(Descrip2D)
		ThisDrawing.SendCommand "AMSKMODE" & vbCr & "0" & vbCr
	End If

End function

function setUCS(transMat) As AcadUCS
	Dim origin(0 To 2) As Double
	Dim xAxis(0 To 2) As Double
	Dim yAxis(0 To 2) As Double
	Dim UCS As AcadUCS
	origin(0) = transMat(0, 3): origin(1) = transMat(1, 3): origin(2) = transMat(2, 3)
	xAxis(0) = transMat(0, 0)+transMat(0,3): xAxis(1) = transMat(1, 0)+transMat(1,3): xAxis(2) = transMat(2, 0)+transMat(2,3)
	yAxis(0) = transMat(0, 1)+transMat(0,3): yAxis(1) = transMat(1, 1)+transMat(1,3): yAxis(2) = transMat(2, 1)+transMat(2,3)
	Set UCS = ThisDrawing.UserCoordinateSystems.Add(origin, xAxis, yAxis, "MyUCS")
	ThisDrawing.ActiveUCS=UCS
End function

function setxyUCS()
	Dim origin(0 To 2) As Double
	Dim xAxis(0 To 2) As Double
	Dim yAxis(0 To 2) As Double
	Dim UCS As AcadUCS
	origin(0) = 0#: origin(1) = 0#: origin(2) = 0#
	xAxis(0) = 1#: xAxis(1) = 0#: xAxis(2) = 0#
	yAxis(0) = 0#: yAxis(1) = 1#: yAxis(2) = 0#
	Set UCS = ThisDrawing.UserCoordinateSystems.Add(origin, xAxis, yAxis, "NormalUCS")
	ThisDrawing.ActiveUCS=UCS
End function

function createSketchPlane(transMat,Util As Object,Ge As Object,Part As Object) As Object
	Dim Locs As Object
	Dim AbsoluteLoc As Object
	Dim CoordSys As Object
	Dim SketchPlaneDescrip As Object
	Dim SketchPlane As Object
	setUCS(transMat)
	Set Locs=Util.CreateCollection(13)
	Set AbsoluteLoc=Util.CreateLocator(11)
	AbsoluteLoc.AbsoluteType=3
	Locs.Add AbsoluteLoc
	Set CoordSys=Util.CreateLocator(14)
	CoordSys.NormalOrientation=0
	CoordSys.AlignmentVector=Ge.Vector(cstr(transMat(0,0)),cstr(transMat(1,0)),cstr(transMat(2,0)))
	Locs.Add CoordSys
	Set SketchPlaneDescrip=Util.CreateFeatureDescriptor(33)
	SketchPlaneDescrip.Locators=Locs
	Set SketchPlane=Part.AddSketchPlane(SketchPlaneDescrip)
	setxyUCS
	Set CreateSketchPlane=SketchPlane
end function

sub CreateNewAssembly(AssmMatrix,Name,MCad As Object,Ge As Object)
	Dim AssmManager As Object
	Dim AssemblyMatrix As Object
	Set AssemblyMatrix=Ge.Matrix
	AssemblyMatrix.AsArray=AssmMatrix
	Set AssmManager=mcad.ActiveDocument.assemblyMgr
	Set Definition=AssmManager.ActiveDefinition
	Set AssemblyComponentDefinition=AssmManager.AddNewCompDef(Name)
	Set AssemblyComponent=Definition.AddComponent(AssemblyComponentDefinition, AssemblyMatrix)
	AssmManager.ActiveDefinition=AssemblyComponentDefinition
end sub

function existsFile(PartName)

searchName=Dir(PartName)
	if(searchName<>"")then
		existsFile=1
	else
		extistsFile=0
	end if
end function

function StoreWindow()
	PathName=InputBox("Enter Path (e.g. c:\mdtfiles )                                   ZielPfad eingeben")
	Index = Len(PathName)
	If (Index<>0) Then
		LastChar = Mid(PathName, Index, 1)
	else
		LastChar=""
	End If
	If (LastChar = "\") Then
		PathName = Left(PathName, Index - 1)
	End If
	searchName=Dir(PathName+"",16)
	if((searchName="")Or(Index=0))then
		t=MsgBox("Folder Not Found! Restart Macro!", 16, "MsgBox Error Message")
		PathName=""
	End If
	StoreWindow=PathName
end function
function CreateSketch0(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	StartPoint(0)=-160#: StartPoint(1)=70#: StartPoint(2)= 0#
	EndPoint(0)=-160#: EndPoint(1)=-70#: EndPoint(2)= 0#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=-160#: StartPoint(1)=-70#: StartPoint(2)= 0#
	EndPoint(0)=160#: EndPoint(1)=-70#: EndPoint(2)= 0#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=160#: StartPoint(1)=-70#: StartPoint(2)= 0#
	EndPoint(0)=160#: EndPoint(1)=70#: EndPoint(2)= 0#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=160#: StartPoint(1)=70#: StartPoint(2)= 0#
	EndPoint(0)=-160#: EndPoint(1)=70#: EndPoint(2)= 0#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSketch1(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=147#: CenterPoint(1)=57.5#: CenterPoint(2)=0#
	Radius=6.25#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSketch2(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=147#: CenterPoint(1)=-57.5#: CenterPoint(2)=0#
	Radius=6.25#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSketch3(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=-147#: CenterPoint(1)=-57.5#: CenterPoint(2)=0#
	Radius=6.25#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSketch4(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=-147#: CenterPoint(1)=57.5#: CenterPoint(2)=0#
	Radius=6.25#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid0(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=1#: transMat(0,1)=0#: transMat(0,2)=0#: transMat(0,3)=0#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=0#
	transMat(2,0)=0#: transMat(2,1)=0#: transMat(2,2)=1#: transMat(2,3)=0#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch0(transMat)
	call CreateSketch1(transMat)
	call CreateSketch2(transMat)
	call CreateSketch3(transMat)
	call CreateSketch4(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=70
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=0
	ExtrusionDescriptor.Direction=ge.Vector(0,0,1)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch5(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=13#: CenterPoint(1)=127.5#: CenterPoint(2)=0#
	Radius=9#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid1(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=1#: transMat(0,1)=0#: transMat(0,2)=0#: transMat(0,3)=-160#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=-70#
	transMat(2,0)=0#: transMat(2,1)=0#: transMat(2,2)=1#: transMat(2,3)=70#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch5(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=12
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(0,0,-1)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch6(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=13#: CenterPoint(1)=12.5#: CenterPoint(2)=0#
	Radius=9#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid2(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=1#: transMat(0,1)=0#: transMat(0,2)=0#: transMat(0,3)=-160#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=-70#
	transMat(2,0)=0#: transMat(2,1)=0#: transMat(2,2)=1#: transMat(2,3)=70#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch6(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=12
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(0,0,-1)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch7(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=307#: CenterPoint(1)=12.5#: CenterPoint(2)=0#
	Radius=9#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid3(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=1#: transMat(0,1)=0#: transMat(0,2)=0#: transMat(0,3)=-160#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=-70#
	transMat(2,0)=0#: transMat(2,1)=0#: transMat(2,2)=1#: transMat(2,3)=70#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch7(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=12
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(0,0,-1)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch8(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=307#: CenterPoint(1)=127.5#: CenterPoint(2)=0#
	Radius=9#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid4(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=1#: transMat(0,1)=0#: transMat(0,2)=0#: transMat(0,3)=-160#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=-70#
	transMat(2,0)=0#: transMat(2,1)=0#: transMat(2,2)=1#: transMat(2,3)=70#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch8(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=12
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(0,0,-1)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch9(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=87.5#: CenterPoint(1)=70#: CenterPoint(2)=0#
	Radius=59.75#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid5(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=1#: transMat(0,1)=0#: transMat(0,2)=0#: transMat(0,3)=-160#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=-70#
	transMat(2,0)=0#: transMat(2,1)=0#: transMat(2,2)=1#: transMat(2,3)=70#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch9(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=146
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=1
	ExtrusionDescriptor.Direction=ge.Vector(0,0,1)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch10(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=232.5#: CenterPoint(1)=70#: CenterPoint(2)=0#
	Radius=59.75#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid6(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=1#: transMat(0,1)=0#: transMat(0,2)=0#: transMat(0,3)=-160#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=-70#
	transMat(2,0)=0#: transMat(2,1)=0#: transMat(2,2)=1#: transMat(2,3)=70#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch10(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=106
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=1
	ExtrusionDescriptor.Direction=ge.Vector(0,0,1)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch11(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=0#: CenterPoint(1)=0#: CenterPoint(2)=0#
	Radius=35#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid7(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=1#: transMat(0,1)=0#: transMat(0,2)=0#: transMat(0,3)=72.5#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=0#
	transMat(2,0)=0#: transMat(2,1)=0#: transMat(2,2)=1#: transMat(2,3)=176#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch11(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=42
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(0,0,-1)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch12(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=0#: CenterPoint(1)=0#: CenterPoint(2)=0#
	Radius=51.75#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid8(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=1#: transMat(0,1)=0#: transMat(0,2)=0#: transMat(0,3)=-72.5#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=0#
	transMat(2,0)=0#: transMat(2,1)=0#: transMat(2,2)=1#: transMat(2,3)=216#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch12(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=0.5
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(0,0,-1)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch13(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=0#: CenterPoint(1)=0#: CenterPoint(2)=0#
	Radius=49.75#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid9(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=1#: transMat(0,1)=0#: transMat(0,2)=0#: transMat(0,3)=-72.5#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=0#
	transMat(2,0)=0#: transMat(2,1)=0#: transMat(2,2)=1#: transMat(2,3)=216#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch13(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=0.5
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=1
	ExtrusionDescriptor.Direction=ge.Vector(0,0,-1)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch14(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=0#: CenterPoint(1)=0#: CenterPoint(2)=0#
	Radius=3#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid10(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=1#: transMat(0,1)=0#: transMat(0,2)=0#: transMat(0,3)=-72.5#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=0#
	transMat(2,0)=0#: transMat(2,1)=0#: transMat(2,2)=1#: transMat(2,3)=216#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch14(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=5
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(0,0,-1)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch15(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=0#: CenterPoint(1)=0#: CenterPoint(2)=0#
	Radius=65.75#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSketch16(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=-2.1316282072803e-014#: CenterPoint(1)=-2.1316282072803e-014#: CenterPoint(2)=0#
	StartAngle=3.1580543024086#
	EndAngle=4.6959273315659#
	Radius=60.75#
	Set EntObj=createArc(CenterPoint,StartAngle,EndAngle,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=-73.5#: StartPoint(1)=-60.741768989716#: StartPoint(2)= 216#
	EndPoint(0)=-73.5#: EndPoint(1)=-57.741341342231#: EndPoint(2)= 216#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	CenterPoint(0)=2.0516921495073e-013#: CenterPoint(1)=6.5767835621955e-011#: CenterPoint(2)=0#
	StartAngle=4.6950720975999#
	EndAngle=4.7297058631694#
	Radius=57.750000000066#
	Set EntObj=createArc(CenterPoint,StartAngle,EndAngle,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=-71.5#: StartPoint(1)=-57.741341342231#: StartPoint(2)= 216#
	EndPoint(0)=-71.5#: EndPoint(1)=-60.741768989716#: EndPoint(2)= 216#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	CenterPoint(0)=0#: CenterPoint(1)=7.105427357601e-015#: CenterPoint(2)=0#
	StartAngle=4.7288506292035#
	EndAngle=6.2667236583608#
	Radius=60.75#
	Set EntObj=createArc(CenterPoint,StartAngle,EndAngle,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=-11.758231010284#: StartPoint(1)=-1#: StartPoint(2)= 216#
	EndPoint(0)=-14.758658657769#: EndPoint(1)=-1#: EndPoint(2)= 216#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	CenterPoint(0)=-4.2277292777726e-011#: CenterPoint(1)=0#: CenterPoint(2)=0#
	StartAngle=6.2658684243948#
	EndAngle=0.017316882784754#
	Radius=57.750000000042#
	Set EntObj=createArc(CenterPoint,StartAngle,EndAngle,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=-14.758658657769#: StartPoint(1)=1#: StartPoint(2)= 216#
	EndPoint(0)=-11.758231010284#: EndPoint(1)=1#: EndPoint(2)= 216#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	CenterPoint(0)=0#: CenterPoint(1)=1.4210854715202e-014#: CenterPoint(2)=0#
	StartAngle=0.016461648818789#
	EndAngle=1.5543346779761#
	Radius=60.75#
	Set EntObj=createArc(CenterPoint,StartAngle,EndAngle,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=-71.5#: StartPoint(1)=60.741768989716#: StartPoint(2)= 216#
	EndPoint(0)=-71.5#: EndPoint(1)=57.741341342231#: EndPoint(2)= 216#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	CenterPoint(0)=1.7763568394003e-015#: CenterPoint(1)=-4.2277292777726e-011#: CenterPoint(2)=0#
	StartAngle=1.5534794440101#
	EndAngle=1.5881132095796#
	Radius=57.750000000042#
	Set EntObj=createArc(CenterPoint,StartAngle,EndAngle,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=-73.5#: StartPoint(1)=57.741341342231#: StartPoint(2)= 216#
	EndPoint(0)=-73.5#: EndPoint(1)=60.741768989716#: EndPoint(2)= 216#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	CenterPoint(0)=-1.4210854715202e-014#: CenterPoint(1)=0#: CenterPoint(2)=0#
	StartAngle=1.5872579756137#
	EndAngle=3.125131004771#
	Radius=60.75#
	Set EntObj=createArc(CenterPoint,StartAngle,EndAngle,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=-133.24176898972#: StartPoint(1)=1#: StartPoint(2)= 216#
	EndPoint(0)=-130.24134134223#: EndPoint(1)=1#: EndPoint(2)= 216#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	CenterPoint(0)=6.5966787587968e-011#: CenterPoint(1)=-2.0516921495073e-013#: CenterPoint(2)=0#
	StartAngle=3.124275770805#
	EndAngle=3.1589095363745#
	Radius=57.750000000066#
	Set EntObj=createArc(CenterPoint,StartAngle,EndAngle,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=-130.24134134223#: StartPoint(1)=-1#: StartPoint(2)= 216#
	EndPoint(0)=-133.24176898972#: EndPoint(1)=-1#: EndPoint(2)= 216#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid11(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=1#: transMat(0,1)=0#: transMat(0,2)=0#: transMat(0,3)=-72.5#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=0#
	transMat(2,0)=0#: transMat(2,1)=0#: transMat(2,2)=1#: transMat(2,3)=216#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch15(transMat)
	call CreateSketch16(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=5
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(0,0,-1)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function


sub CreatePart0(MCad As Object,Util As Object,Ge As Object,PathName)
	Dim Part As Object
	Set EntityDic = CreateObject("Scripting.Dictionary")
	Dim Instance As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim ParentAssembly As Object
	Dim Definition As Object
	transMat(0,0)=1#: transMat(0,1)=0#: transMat(0,2)=0#: transMat(0,3)=0#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=0#
	transMat(2,0)=0#: transMat(2,1)=0#: transMat(2,2)=1#: transMat(2,3)=0#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Set PartMatrix=Ge.Matrix
	PartMatrix.AsArray=transMat
	Set ParentAssembly=MCad.ActiveDocument.AssemblyMgr.ActiveDefinition
	FileName=PathName+"\SN5600BPOS11200025HUBXL0.dwg"
	if(existsFile(FileName)=1)then
		Set Definition=MCad.ActiveDocument.AssemblyMgr.AddCompDefFromFile(FileName,"SN5600BPOS11200025HUBXL0")
		Set Component=MCad.ActiveDocument.assemblyMgr.ActiveDefinition.AddComponent(Definition, PartMatrix)
	else
		Set Part=MCad.ActiveDocument.AddNewPart("SN5600BPOS11200025HUBXL0")
		Set Instance=MCad.ActiveDocument.AssemblyMgr.ActiveInstance
		call CreateSolid0(MCad,Util,Ge,Part,Instance)
		call CreateSolid1(MCad,Util,Ge,Part,Instance)
		call CreateSolid2(MCad,Util,Ge,Part,Instance)
		call CreateSolid3(MCad,Util,Ge,Part,Instance)
		call CreateSolid4(MCad,Util,Ge,Part,Instance)
		call CreateSolid5(MCad,Util,Ge,Part,Instance)
		call CreateSolid6(MCad,Util,Ge,Part,Instance)
		call CreateSolid7(MCad,Util,Ge,Part,Instance)
		call CreateSolid8(MCad,Util,Ge,Part,Instance)
		call CreateSolid9(MCad,Util,Ge,Part,Instance)
		call CreateSolid10(MCad,Util,Ge,Part,Instance)
		call CreateSolid11(MCad,Util,Ge,Part,Instance)
		Part.Definition.Externalize FileName
		Instance.Position=PartMatrix
	end if
	MCad.ActiveDocument.AssemblyMgr.ActiveDefinition=ParentAssembly
end sub
function CreateSketch17(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=0#: CenterPoint(1)=0#: CenterPoint(2)=0#
	Radius=35#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid12(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=1#: transMat(0,1)=0#: transMat(0,2)=0#: transMat(0,3)=0#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=0#
	transMat(2,0)=0#: transMat(2,1)=0#: transMat(2,2)=1#: transMat(2,3)=0#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch17(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=40
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=0
	ExtrusionDescriptor.Direction=ge.Vector(0,0,1)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch18(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=0#: CenterPoint(1)=0#: CenterPoint(2)=0#
	Radius=3#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid13(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=1#: transMat(0,1)=0#: transMat(0,2)=0#: transMat(0,3)=0#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=0#
	transMat(2,0)=0#: transMat(2,1)=0#: transMat(2,2)=1#: transMat(2,3)=40#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch18(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=5
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(0,0,-1)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function


sub CreatePart1(MCad As Object,Util As Object,Ge As Object,PathName)
	Dim Part As Object
	Set EntityDic = CreateObject("Scripting.Dictionary")
	Dim Instance As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim ParentAssembly As Object
	Dim Definition As Object
	transMat(0,0)=1#: transMat(0,1)=0#: transMat(0,2)=0#: transMat(0,3)=72.5#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=0#
	transMat(2,0)=0#: transMat(2,1)=0#: transMat(2,2)=1#: transMat(2,3)=176#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Set PartMatrix=Ge.Matrix
	PartMatrix.AsArray=transMat
	Set ParentAssembly=MCad.ActiveDocument.AssemblyMgr.ActiveDefinition
	FileName=PathName+"\SN5600BPOS21200025.dwg"
	if(existsFile(FileName)=1)then
		Set Definition=MCad.ActiveDocument.AssemblyMgr.AddCompDefFromFile(FileName,"SN5600BPOS21200025")
		Set Component=MCad.ActiveDocument.assemblyMgr.ActiveDefinition.AddComponent(Definition, PartMatrix)
	else
		Set Part=MCad.ActiveDocument.AddNewPart("SN5600BPOS21200025")
		Set Instance=MCad.ActiveDocument.AssemblyMgr.ActiveInstance
		call CreateSolid12(MCad,Util,Ge,Part,Instance)
		call CreateSolid13(MCad,Util,Ge,Part,Instance)
		Part.Definition.Externalize FileName
		Instance.Position=PartMatrix
	end if
	MCad.ActiveDocument.AssemblyMgr.ActiveDefinition=ParentAssembly
end sub

sub CreateAssembly0(MCad As Object,Util As Object,Ge As Object,PathName)
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim ParentAssembly As Object
	Dim Definition As Object
	transMat(0,0)=1#: transMat(0,1)=0#: transMat(0,2)=0#: transMat(0,3)=0#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=0#
	transMat(2,0)=0#: transMat(2,1)=0#: transMat(2,2)=1#: transMat(2,3)=0#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Set AssmMatrix=Ge.Matrix
	AssmMatrix.AsArray=transMat
	Set ParentAssembly=MCad.ActiveDocument.AssemblyMgr.ActiveDefinition
	FileName=PathName+"\SN5600B1200025HUBXL0.dwg"
	if(existsFile(FileName)=1)then
		Set Definition=MCad.ActiveDocument.AssemblyMgr.AddCompDefFromFile(FileName,"SN5600B1200025HUBXL0")
		Set Component=MCad.ActiveDocument.assemblyMgr.ActiveDefinition.AddComponent(Definition, AssmMatrix)
	else
		AssemblyName="SN5600B1200025HUBXL0"
		Call CreateNewAssembly(transMat,AssemblyName,MCad,Ge)
		call CreatePart0(MCad,Util,Ge,PathName)
		call CreatePart1(MCad,Util,Ge,PathName)
		MCad.ActiveDocument.AssemblyMgr.ActiveDefinition.Externalize FileName
	end if
	MCad.ActiveDocument.AssemblyMgr.ActiveDefinition=ParentAssembly
end sub


Sub Main()

	ThisDrawing.SendCommand "AMSKMODE" & vbCr & "0" & vbCr
	PathName=StoreWindow
	if(PathName<>"")then
		Dim MCad As Object
		Set MCad=ThisDrawing.Application.GetInterfaceObject("Mcad.Application")
		Dim Util As Object
		Set Util=MCad.ActiveDocument.Utility
		Dim Ge As Object
		Set Ge=ThisDrawing.Application.GetInterfaceObject("Ge.Application")
		setxyUCS
		call CreateAssembly0(MCad,Util,Ge,PathName)
	end if

end sub

