Dim EntityDic
Dim Count

function createLine(StartPoint,EndPoint)

	Dim LineObj As AcadLine
	Set LineObj=ThisDrawing.ModelSpace.AddLine(StartPoint,EndPoint)
	Set createLine=LineObj

End function

function createArc(CenterPoint,StartAngle,EndAngle,Radius,Matrix)

	Dim ArcObj As AcadArc
	Set ArcObj=ThisDrawing.ModelSpace.AddArc(CenterPoint,Radius,StartAngle,EndAngle)
	ArcObj.TransformBy(Matrix)
	Set createArc=ArcObj

End function

function createCircle(CenterPoint,Radius,Matrix)

	Dim CircleObj As AcadCircle
	Set CircleObj=ThisDrawing.ModelSpace.AddCircle(CenterPoint,Radius)
	CircleObj.TransformBy(Matrix)
	Set createCircle=CircleObj

End function

function createProfile(Part As Object,Util As Object,SketchPlane As Object,Instance As Object) As Object

	ReDim Sels(0 To EntityDic.Count-1)
	For I=0 To EntityDic.Count-1

		Set Entity=EntityDic.Item(cstr(I))
		Set Sels(I)=Entity

	Next
	Dim Descrip2D As Object
	Set Descrip2D = Util.CreateSketchDescriptor(2)
	Descrip2D.SketchPlane=SketchPlane
	Descrip2D.ScopeObject=Instance
	Descrip2D.InferConstraints=True
	Descrip2D.Selections=Sels
	On Error Resume Next
	Set CreateProfile=Part.AddSketch(descrip2D)
	If (Err.Number <> 0) Then
		Err.Clear
		ThisDrawing.SendCommand "AMSKMODE" & vbCr & "1" & vbCr
		Set CreateProfile = Part.AddSketch(Descrip2D)
		ThisDrawing.SendCommand "AMSKMODE" & vbCr & "0" & vbCr
	End If

End function

function setUCS(transMat) As AcadUCS
	Dim origin(0 To 2) As Double
	Dim xAxis(0 To 2) As Double
	Dim yAxis(0 To 2) As Double
	Dim UCS As AcadUCS
	origin(0) = transMat(0, 3): origin(1) = transMat(1, 3): origin(2) = transMat(2, 3)
	xAxis(0) = transMat(0, 0)+transMat(0,3): xAxis(1) = transMat(1, 0)+transMat(1,3): xAxis(2) = transMat(2, 0)+transMat(2,3)
	yAxis(0) = transMat(0, 1)+transMat(0,3): yAxis(1) = transMat(1, 1)+transMat(1,3): yAxis(2) = transMat(2, 1)+transMat(2,3)
	Set UCS = ThisDrawing.UserCoordinateSystems.Add(origin, xAxis, yAxis, "MyUCS")
	ThisDrawing.ActiveUCS=UCS
End function

function setxyUCS()
	Dim origin(0 To 2) As Double
	Dim xAxis(0 To 2) As Double
	Dim yAxis(0 To 2) As Double
	Dim UCS As AcadUCS
	origin(0) = 0#: origin(1) = 0#: origin(2) = 0#
	xAxis(0) = 1#: xAxis(1) = 0#: xAxis(2) = 0#
	yAxis(0) = 0#: yAxis(1) = 1#: yAxis(2) = 0#
	Set UCS = ThisDrawing.UserCoordinateSystems.Add(origin, xAxis, yAxis, "NormalUCS")
	ThisDrawing.ActiveUCS=UCS
End function

function createSketchPlane(transMat,Util As Object,Ge As Object,Part As Object) As Object
	Dim Locs As Object
	Dim AbsoluteLoc As Object
	Dim CoordSys As Object
	Dim SketchPlaneDescrip As Object
	Dim SketchPlane As Object
	setUCS(transMat)
	Set Locs=Util.CreateCollection(13)
	Set AbsoluteLoc=Util.CreateLocator(11)
	AbsoluteLoc.AbsoluteType=3
	Locs.Add AbsoluteLoc
	Set CoordSys=Util.CreateLocator(14)
	CoordSys.NormalOrientation=0
	CoordSys.AlignmentVector=Ge.Vector(cstr(transMat(0,0)),cstr(transMat(1,0)),cstr(transMat(2,0)))
	Locs.Add CoordSys
	Set SketchPlaneDescrip=Util.CreateFeatureDescriptor(33)
	SketchPlaneDescrip.Locators=Locs
	Set SketchPlane=Part.AddSketchPlane(SketchPlaneDescrip)
	setxyUCS
	Set CreateSketchPlane=SketchPlane
end function

sub CreateNewAssembly(AssmMatrix,Name,MCad As Object,Ge As Object)
	Dim AssmManager As Object
	Dim AssemblyMatrix As Object
	Set AssemblyMatrix=Ge.Matrix
	AssemblyMatrix.AsArray=AssmMatrix
	Set AssmManager=mcad.ActiveDocument.assemblyMgr
	Set Definition=AssmManager.ActiveDefinition
	Set AssemblyComponentDefinition=AssmManager.AddNewCompDef(Name)
	Set AssemblyComponent=Definition.AddComponent(AssemblyComponentDefinition, AssemblyMatrix)
	AssmManager.ActiveDefinition=AssemblyComponentDefinition
end sub

function existsFile(PartName)

searchName=Dir(PartName)
	if(searchName<>"")then
		existsFile=1
	else
		extistsFile=0
	end if
end function

function StoreWindow()
	PathName=InputBox("Enter Path (e.g. c:\mdtfiles )                                   ZielPfad eingeben")
	Index = Len(PathName)
	If (Index<>0) Then
		LastChar = Mid(PathName, Index, 1)
	else
		LastChar=""
	End If
	If (LastChar = "\") Then
		PathName = Left(PathName, Index - 1)
	End If
	searchName=Dir(PathName+"",16)
	if((searchName="")Or(Index=0))then
		t=MsgBox("Folder Not Found! Restart Macro!", 16, "MsgBox Error Message")
		PathName=""
	End If
	StoreWindow=PathName
end function
function CreateSketch0(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	StartPoint(0)=-82#: StartPoint(1)=70#: StartPoint(2)= 0#
	EndPoint(0)=-82#: EndPoint(1)=-70#: EndPoint(2)= 0#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=-82#: StartPoint(1)=-70#: StartPoint(2)= 0#
	EndPoint(0)=79#: EndPoint(1)=-70#: EndPoint(2)= 0#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=79#: StartPoint(1)=-70#: StartPoint(2)= 0#
	EndPoint(0)=79#: EndPoint(1)=70#: EndPoint(2)= 0#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=79#: StartPoint(1)=70#: StartPoint(2)= 0#
	EndPoint(0)=-82#: EndPoint(1)=70#: EndPoint(2)= 0#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSketch1(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=50#: CenterPoint(1)=-55#: CenterPoint(2)=0#
	Radius=8#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSketch2(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=50#: CenterPoint(1)=55#: CenterPoint(2)=0#
	Radius=8#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSketch3(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=-17#: CenterPoint(1)=-55#: CenterPoint(2)=0#
	Radius=8#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSketch4(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=-17#: CenterPoint(1)=55#: CenterPoint(2)=0#
	Radius=8#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSketch5(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=-67#: CenterPoint(1)=-55#: CenterPoint(2)=0#
	Radius=8#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSketch6(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=-67#: CenterPoint(1)=55#: CenterPoint(2)=0#
	Radius=8#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid0(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=1#: transMat(0,1)=0#: transMat(0,2)=0#: transMat(0,3)=0#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=0#
	transMat(2,0)=0#: transMat(2,1)=0#: transMat(2,2)=1#: transMat(2,3)=0#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch0(transMat)
	call CreateSketch1(transMat)
	call CreateSketch2(transMat)
	call CreateSketch3(transMat)
	call CreateSketch4(transMat)
	call CreateSketch5(transMat)
	call CreateSketch6(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=127
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=0
	ExtrusionDescriptor.Direction=ge.Vector(0,0,1)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch7(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	StartPoint(0)=0#: StartPoint(1)=70#: StartPoint(2)= 0#
	EndPoint(0)=25#: EndPoint(1)=70#: EndPoint(2)= 0#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=25#: StartPoint(1)=70#: StartPoint(2)= 0#
	EndPoint(0)=25#: EndPoint(1)=-70#: EndPoint(2)= 0#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=25#: StartPoint(1)=-70#: StartPoint(2)= 0#
	EndPoint(0)=0#: EndPoint(1)=-70#: EndPoint(2)= 0#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=0#: StartPoint(1)=-70#: StartPoint(2)= 0#
	EndPoint(0)=0#: EndPoint(1)=70#: EndPoint(2)= 0#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid1(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=1#: transMat(0,1)=0#: transMat(0,2)=0#: transMat(0,3)=-82#
	transMat(1,0)=0#: transMat(1,1)=-1#: transMat(1,2)=0#: transMat(1,3)=70#
	transMat(2,0)=0#: transMat(2,1)=0#: transMat(2,2)=-1#: transMat(2,3)=0#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch7(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=8
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(0,0,1)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch8(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	StartPoint(0)=-82#: StartPoint(1)=43#: StartPoint(2)= 127#
	EndPoint(0)=-67#: EndPoint(1)=43#: EndPoint(2)= 127#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	CenterPoint(0)=-67#: CenterPoint(1)=55#: CenterPoint(2)=0#
	StartAngle=4.7123889803847#
	EndAngle=0#
	Radius=12#
	Set EntObj=createArc(CenterPoint,StartAngle,EndAngle,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=-55#: StartPoint(1)=55#: StartPoint(2)= 127#
	EndPoint(0)=-55#: EndPoint(1)=70#: EndPoint(2)= 127#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=-55#: StartPoint(1)=70#: StartPoint(2)= 127#
	EndPoint(0)=38#: EndPoint(1)=70#: EndPoint(2)= 127#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=38#: StartPoint(1)=70#: StartPoint(2)= 127#
	EndPoint(0)=38#: EndPoint(1)=55#: EndPoint(2)= 127#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	CenterPoint(0)=50#: CenterPoint(1)=55#: CenterPoint(2)=0#
	StartAngle=3.1415926535898#
	EndAngle=0#
	Radius=12#
	Set EntObj=createArc(CenterPoint,StartAngle,EndAngle,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=62#: StartPoint(1)=55#: StartPoint(2)= 127#
	EndPoint(0)=62#: EndPoint(1)=70.3#: EndPoint(2)= 127#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=62#: StartPoint(1)=70.3#: StartPoint(2)= 127#
	EndPoint(0)=-82#: EndPoint(1)=70.3#: EndPoint(2)= 127#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=-82#: StartPoint(1)=70.3#: StartPoint(2)= 127#
	EndPoint(0)=-82#: EndPoint(1)=43#: EndPoint(2)= 127#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid2(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=1#: transMat(0,1)=0#: transMat(0,2)=0#: transMat(0,3)=0#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=0#
	transMat(2,0)=0#: transMat(2,1)=0#: transMat(2,2)=1#: transMat(2,3)=127#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch8(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=20
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(0,0,-1)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch9(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	StartPoint(0)=-82#: StartPoint(1)=-43#: StartPoint(2)= 127#
	EndPoint(0)=-82#: EndPoint(1)=-70.3#: EndPoint(2)= 127#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=-82#: StartPoint(1)=-70.3#: StartPoint(2)= 127#
	EndPoint(0)=62#: EndPoint(1)=-70.3#: EndPoint(2)= 127#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=62#: StartPoint(1)=-70.3#: StartPoint(2)= 127#
	EndPoint(0)=62#: EndPoint(1)=-55#: EndPoint(2)= 127#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	CenterPoint(0)=50#: CenterPoint(1)=-55#: CenterPoint(2)=0#
	StartAngle=0#
	EndAngle=3.1415926535898#
	Radius=12#
	Set EntObj=createArc(CenterPoint,StartAngle,EndAngle,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=38#: StartPoint(1)=-55#: StartPoint(2)= 127#
	EndPoint(0)=38#: EndPoint(1)=-70#: EndPoint(2)= 127#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=38#: StartPoint(1)=-70#: StartPoint(2)= 127#
	EndPoint(0)=-55#: EndPoint(1)=-70#: EndPoint(2)= 127#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=-55#: StartPoint(1)=-70#: StartPoint(2)= 127#
	EndPoint(0)=-55#: EndPoint(1)=-55#: EndPoint(2)= 127#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	CenterPoint(0)=-67#: CenterPoint(1)=-55#: CenterPoint(2)=0#
	StartAngle=0#
	EndAngle=1.5707963267949#
	Radius=12#
	Set EntObj=createArc(CenterPoint,StartAngle,EndAngle,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=-67#: StartPoint(1)=-43#: StartPoint(2)= 127#
	EndPoint(0)=-82#: EndPoint(1)=-43#: EndPoint(2)= 127#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid3(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=1#: transMat(0,1)=0#: transMat(0,2)=0#: transMat(0,3)=0#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=0#
	transMat(2,0)=0#: transMat(2,1)=0#: transMat(2,2)=1#: transMat(2,3)=127#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch9(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=20
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(0,0,-1)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch10(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	StartPoint(0)=0#: StartPoint(1)=-70#: StartPoint(2)= 127#
	EndPoint(0)=0#: EndPoint(1)=-70#: EndPoint(2)= 114#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=0#: StartPoint(1)=-70#: StartPoint(2)= 114#
	EndPoint(0)=12#: EndPoint(1)=-70#: EndPoint(2)= 114#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=12#: StartPoint(1)=-70#: StartPoint(2)= 114#
	EndPoint(0)=12#: EndPoint(1)=-70#: EndPoint(2)= 127#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=12#: StartPoint(1)=-70#: StartPoint(2)= 127#
	EndPoint(0)=0#: EndPoint(1)=-70#: EndPoint(2)= 127#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid4(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=1#: transMat(0,1)=0#: transMat(0,2)=0#: transMat(0,3)=-82#
	transMat(1,0)=0#: transMat(1,1)=0#: transMat(1,2)=-1#: transMat(1,3)=-70#
	transMat(2,0)=0#: transMat(2,1)=1#: transMat(2,2)=0#: transMat(2,3)=0#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch10(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=0.1
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(0,1,0)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch11(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	StartPoint(0)=0#: StartPoint(1)=-70#: StartPoint(2)= 127#
	EndPoint(0)=12#: EndPoint(1)=-70#: EndPoint(2)= 127#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=12#: StartPoint(1)=-70#: StartPoint(2)= 127#
	EndPoint(0)=12#: EndPoint(1)=70#: EndPoint(2)= 127#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=12#: StartPoint(1)=70#: StartPoint(2)= 127#
	EndPoint(0)=0#: EndPoint(1)=70#: EndPoint(2)= 127#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=0#: StartPoint(1)=70#: StartPoint(2)= 127#
	EndPoint(0)=0#: EndPoint(1)=-70#: EndPoint(2)= 127#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid5(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=1#: transMat(0,1)=0#: transMat(0,2)=0#: transMat(0,3)=0#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=0#
	transMat(2,0)=0#: transMat(2,1)=0#: transMat(2,2)=1#: transMat(2,3)=127#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch11(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=0.1
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(0,0,-1)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch12(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	StartPoint(0)=0#: StartPoint(1)=70#: StartPoint(2)= 127#
	EndPoint(0)=12#: EndPoint(1)=70#: EndPoint(2)= 127#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=12#: StartPoint(1)=70#: StartPoint(2)= 127#
	EndPoint(0)=12#: EndPoint(1)=70#: EndPoint(2)= 114#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=12#: StartPoint(1)=70#: StartPoint(2)= 114#
	EndPoint(0)=0#: EndPoint(1)=70#: EndPoint(2)= 114#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=0#: StartPoint(1)=70#: StartPoint(2)= 114#
	EndPoint(0)=0#: EndPoint(1)=70#: EndPoint(2)= 127#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid6(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=1#: transMat(0,1)=0#: transMat(0,2)=0#: transMat(0,3)=-82#
	transMat(1,0)=0#: transMat(1,1)=0#: transMat(1,2)=1#: transMat(1,3)=70#
	transMat(2,0)=0#: transMat(2,1)=-1#: transMat(2,2)=0#: transMat(2,3)=0#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch12(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=0.1
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(0,-1,0)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch13(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=6#: CenterPoint(1)=-55#: CenterPoint(2)=0#
	Radius=5#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid7(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=1#: transMat(0,1)=0#: transMat(0,2)=0#: transMat(0,3)=0#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=0#
	transMat(2,0)=0#: transMat(2,1)=0#: transMat(2,2)=1#: transMat(2,3)=127#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch13(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=0.2
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(0,0,-1)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch14(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=6#: CenterPoint(1)=55#: CenterPoint(2)=0#
	Radius=5#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid8(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=1#: transMat(0,1)=0#: transMat(0,2)=0#: transMat(0,3)=0#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=0#
	transMat(2,0)=0#: transMat(2,1)=0#: transMat(2,2)=1#: transMat(2,3)=127#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch14(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=0.2
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(0,0,-1)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch15(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	StartPoint(0)=3#: StartPoint(1)=56.732050807569#: StartPoint(2)= 126.8#
	EndPoint(0)=3#: EndPoint(1)=53.267949192431#: EndPoint(2)= 126.8#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=3#: StartPoint(1)=53.267949192431#: StartPoint(2)= 126.8#
	EndPoint(0)=6#: EndPoint(1)=51.535898384862#: EndPoint(2)= 126.8#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=6#: StartPoint(1)=51.535898384862#: StartPoint(2)= 126.8#
	EndPoint(0)=9#: EndPoint(1)=53.267949192431#: EndPoint(2)= 126.8#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=9#: StartPoint(1)=53.267949192431#: StartPoint(2)= 126.8#
	EndPoint(0)=9#: EndPoint(1)=56.732050807569#: EndPoint(2)= 126.8#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=9#: StartPoint(1)=56.732050807569#: StartPoint(2)= 126.8#
	EndPoint(0)=6#: EndPoint(1)=58.464101615138#: EndPoint(2)= 126.8#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=6#: StartPoint(1)=58.464101615138#: StartPoint(2)= 126.8#
	EndPoint(0)=3#: EndPoint(1)=56.732050807569#: EndPoint(2)= 126.8#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid9(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=1#: transMat(0,1)=0#: transMat(0,2)=0#: transMat(0,3)=6#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=55#
	transMat(2,0)=0#: transMat(2,1)=0#: transMat(2,2)=1#: transMat(2,3)=126.8#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch15(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=1.8
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(0,0,-1)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch16(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	StartPoint(0)=3#: StartPoint(1)=-53.267949192431#: StartPoint(2)= 126.8#
	EndPoint(0)=3#: EndPoint(1)=-56.732050807569#: EndPoint(2)= 126.8#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=3#: StartPoint(1)=-56.732050807569#: StartPoint(2)= 126.8#
	EndPoint(0)=6#: EndPoint(1)=-58.464101615138#: EndPoint(2)= 126.8#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=6#: StartPoint(1)=-58.464101615138#: StartPoint(2)= 126.8#
	EndPoint(0)=9#: EndPoint(1)=-56.732050807569#: EndPoint(2)= 126.8#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=9#: StartPoint(1)=-56.732050807569#: StartPoint(2)= 126.8#
	EndPoint(0)=9#: EndPoint(1)=-53.267949192431#: EndPoint(2)= 126.8#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=9#: StartPoint(1)=-53.267949192431#: StartPoint(2)= 126.8#
	EndPoint(0)=6#: EndPoint(1)=-51.535898384862#: EndPoint(2)= 126.8#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=6#: StartPoint(1)=-51.535898384862#: StartPoint(2)= 126.8#
	EndPoint(0)=3#: EndPoint(1)=-53.267949192431#: EndPoint(2)= 126.8#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid10(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=1#: transMat(0,1)=0#: transMat(0,2)=0#: transMat(0,3)=6#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=-55#
	transMat(2,0)=0#: transMat(2,1)=0#: transMat(2,2)=1#: transMat(2,3)=126.8#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch16(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=1.8
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(0,0,-1)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch17(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=-67#: CenterPoint(1)=0#: CenterPoint(2)=0#
	Radius=54.5#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid11(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=0#: transMat(0,1)=0#: transMat(0,2)=1#: transMat(0,3)=79#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=0#
	transMat(2,0)=-1#: transMat(2,1)=0#: transMat(2,2)=0#: transMat(2,3)=0#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch17(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=82
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=1
	ExtrusionDescriptor.Direction=ge.Vector(1,0,0)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch18(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=10#: CenterPoint(1)=117#: CenterPoint(2)=0#
	Radius=8#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid12(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=0#: transMat(0,1)=0#: transMat(0,2)=1#: transMat(0,3)=79#
	transMat(1,0)=1#: transMat(1,1)=0#: transMat(1,2)=0#: transMat(1,3)=-70#
	transMat(2,0)=0#: transMat(2,1)=1#: transMat(2,2)=0#: transMat(2,3)=0#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch18(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=82
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=1
	ExtrusionDescriptor.Direction=ge.Vector(1,0,0)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch19(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=130#: CenterPoint(1)=117#: CenterPoint(2)=0#
	Radius=8#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid13(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=0#: transMat(0,1)=0#: transMat(0,2)=1#: transMat(0,3)=79#
	transMat(1,0)=1#: transMat(1,1)=0#: transMat(1,2)=0#: transMat(1,3)=-70#
	transMat(2,0)=0#: transMat(2,1)=1#: transMat(2,2)=0#: transMat(2,3)=0#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch19(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=82
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=1
	ExtrusionDescriptor.Direction=ge.Vector(1,0,0)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch20(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=130#: CenterPoint(1)=10#: CenterPoint(2)=0#
	Radius=8#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid14(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=0#: transMat(0,1)=0#: transMat(0,2)=1#: transMat(0,3)=79#
	transMat(1,0)=1#: transMat(1,1)=0#: transMat(1,2)=0#: transMat(1,3)=-70#
	transMat(2,0)=0#: transMat(2,1)=1#: transMat(2,2)=0#: transMat(2,3)=0#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch20(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=82
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=1
	ExtrusionDescriptor.Direction=ge.Vector(1,0,0)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch21(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=10#: CenterPoint(1)=10#: CenterPoint(2)=0#
	Radius=8#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid15(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=0#: transMat(0,1)=0#: transMat(0,2)=1#: transMat(0,3)=79#
	transMat(1,0)=1#: transMat(1,1)=0#: transMat(1,2)=0#: transMat(1,3)=-70#
	transMat(2,0)=0#: transMat(2,1)=1#: transMat(2,2)=0#: transMat(2,3)=0#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch21(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=82
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=1
	ExtrusionDescriptor.Direction=ge.Vector(1,0,0)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch22(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	StartPoint(0)=161#: StartPoint(1)=-70#: StartPoint(2)= 127#
	EndPoint(0)=161#: EndPoint(1)=-70#: EndPoint(2)= 0#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=161#: StartPoint(1)=-70#: StartPoint(2)= 0#
	EndPoint(0)=161#: EndPoint(1)=70#: EndPoint(2)= 0#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=161#: StartPoint(1)=70#: StartPoint(2)= 0#
	EndPoint(0)=161#: EndPoint(1)=70#: EndPoint(2)= 127#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=161#: StartPoint(1)=70#: StartPoint(2)= 127#
	EndPoint(0)=161#: EndPoint(1)=-70#: EndPoint(2)= 127#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid16(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=0#: transMat(0,1)=0#: transMat(0,2)=1#: transMat(0,3)=161#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=0#
	transMat(2,0)=-1#: transMat(2,1)=0#: transMat(2,2)=0#: transMat(2,3)=0#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch22(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=20
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=1
	ExtrusionDescriptor.Direction=ge.Vector(1,0,0)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch23(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	StartPoint(0)=181#: StartPoint(1)=-72#: StartPoint(2)= -2#
	EndPoint(0)=181#: EndPoint(1)=72#: EndPoint(2)= -2#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=181#: StartPoint(1)=72#: StartPoint(2)= -2#
	EndPoint(0)=181#: EndPoint(1)=72#: EndPoint(2)= 129#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=181#: StartPoint(1)=72#: StartPoint(2)= 129#
	EndPoint(0)=181#: EndPoint(1)=-72#: EndPoint(2)= 129#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=181#: StartPoint(1)=-72#: StartPoint(2)= 129#
	EndPoint(0)=181#: EndPoint(1)=-72#: EndPoint(2)= -2#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSketch24(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	StartPoint(0)=181#: StartPoint(1)=-70#: StartPoint(2)= 20#
	EndPoint(0)=181#: EndPoint(1)=-60#: EndPoint(2)= 20#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	CenterPoint(0)=10#: CenterPoint(1)=10#: CenterPoint(2)=0#
	StartAngle=0#
	EndAngle=1.5707963267949#
	Radius=10#
	Set EntObj=createArc(CenterPoint,StartAngle,EndAngle,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=181#: StartPoint(1)=-50#: StartPoint(2)= 10#
	EndPoint(0)=181#: EndPoint(1)=-50#: EndPoint(2)= 0#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=181#: StartPoint(1)=-50#: StartPoint(2)= 0#
	EndPoint(0)=181#: EndPoint(1)=50#: EndPoint(2)= 0#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=181#: StartPoint(1)=50#: StartPoint(2)= 0#
	EndPoint(0)=181#: EndPoint(1)=50#: EndPoint(2)= 10#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	CenterPoint(0)=130#: CenterPoint(1)=10#: CenterPoint(2)=0#
	StartAngle=1.5707963267949#
	EndAngle=3.1415926535898#
	Radius=10#
	Set EntObj=createArc(CenterPoint,StartAngle,EndAngle,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=181#: StartPoint(1)=60#: StartPoint(2)= 20#
	EndPoint(0)=181#: EndPoint(1)=70#: EndPoint(2)= 20#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=181#: StartPoint(1)=70#: StartPoint(2)= 20#
	EndPoint(0)=181#: EndPoint(1)=70#: EndPoint(2)= 107#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=181#: StartPoint(1)=70#: StartPoint(2)= 107#
	EndPoint(0)=181#: EndPoint(1)=60#: EndPoint(2)= 107#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	CenterPoint(0)=130#: CenterPoint(1)=117#: CenterPoint(2)=0#
	StartAngle=3.1415926535898#
	EndAngle=4.7123889803847#
	Radius=10#
	Set EntObj=createArc(CenterPoint,StartAngle,EndAngle,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=181#: StartPoint(1)=50#: StartPoint(2)= 117#
	EndPoint(0)=181#: EndPoint(1)=50#: EndPoint(2)= 127#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=181#: StartPoint(1)=50#: StartPoint(2)= 127#
	EndPoint(0)=181#: EndPoint(1)=-50#: EndPoint(2)= 127#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=181#: StartPoint(1)=-50#: StartPoint(2)= 127#
	EndPoint(0)=181#: EndPoint(1)=-50#: EndPoint(2)= 117#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	CenterPoint(0)=10#: CenterPoint(1)=117#: CenterPoint(2)=0#
	StartAngle=4.7123889803847#
	EndAngle=0#
	Radius=10#
	Set EntObj=createArc(CenterPoint,StartAngle,EndAngle,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=181#: StartPoint(1)=-60#: StartPoint(2)= 107#
	EndPoint(0)=181#: EndPoint(1)=-70#: EndPoint(2)= 107#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=181#: StartPoint(1)=-70#: StartPoint(2)= 107#
	EndPoint(0)=181#: EndPoint(1)=-70#: EndPoint(2)= 20#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid17(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=0#: transMat(0,1)=0#: transMat(0,2)=1#: transMat(0,3)=181#
	transMat(1,0)=1#: transMat(1,1)=0#: transMat(1,2)=0#: transMat(1,3)=-70#
	transMat(2,0)=0#: transMat(2,1)=1#: transMat(2,2)=0#: transMat(2,3)=0#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch23(transMat)
	call CreateSketch24(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=16
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(-1,0,0)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch25(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=-10#: CenterPoint(1)=-60#: CenterPoint(2)=0#
	Radius=9.5#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid18(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=0#: transMat(0,1)=0#: transMat(0,2)=1#: transMat(0,3)=165#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=0#
	transMat(2,0)=-1#: transMat(2,1)=0#: transMat(2,2)=0#: transMat(2,3)=0#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch25(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=16
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=1
	ExtrusionDescriptor.Direction=ge.Vector(1,0,0)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch26(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=-10#: CenterPoint(1)=60#: CenterPoint(2)=0#
	Radius=9.5#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid19(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=0#: transMat(0,1)=0#: transMat(0,2)=1#: transMat(0,3)=165#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=0#
	transMat(2,0)=-1#: transMat(2,1)=0#: transMat(2,2)=0#: transMat(2,3)=0#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch26(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=16
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=1
	ExtrusionDescriptor.Direction=ge.Vector(1,0,0)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch27(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=-117#: CenterPoint(1)=-60#: CenterPoint(2)=0#
	Radius=9.5#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid20(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=0#: transMat(0,1)=0#: transMat(0,2)=1#: transMat(0,3)=165#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=0#
	transMat(2,0)=-1#: transMat(2,1)=0#: transMat(2,2)=0#: transMat(2,3)=0#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch27(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=16
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=1
	ExtrusionDescriptor.Direction=ge.Vector(1,0,0)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch28(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=-117#: CenterPoint(1)=60#: CenterPoint(2)=0#
	Radius=9.5#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid21(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=0#: transMat(0,1)=0#: transMat(0,2)=1#: transMat(0,3)=165#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=0#
	transMat(2,0)=-1#: transMat(2,1)=0#: transMat(2,2)=0#: transMat(2,3)=0#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch28(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=16
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=1
	ExtrusionDescriptor.Direction=ge.Vector(1,0,0)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch29(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	StartPoint(0)=181#: StartPoint(1)=-56.535898384862#: StartPoint(2)= 16#
	EndPoint(0)=181#: EndPoint(1)=-63.464101615138#: EndPoint(2)= 16#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=181#: StartPoint(1)=-63.464101615138#: StartPoint(2)= 16#
	EndPoint(0)=181#: EndPoint(1)=-66.928203230276#: EndPoint(2)= 10#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=181#: StartPoint(1)=-66.928203230276#: StartPoint(2)= 10#
	EndPoint(0)=181#: EndPoint(1)=-63.464101615138#: EndPoint(2)= 4#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=181#: StartPoint(1)=-63.464101615138#: StartPoint(2)= 4#
	EndPoint(0)=181#: EndPoint(1)=-56.535898384862#: EndPoint(2)= 4#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=181#: StartPoint(1)=-56.535898384862#: StartPoint(2)= 4#
	EndPoint(0)=181#: EndPoint(1)=-53.071796769724#: EndPoint(2)= 10#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=181#: StartPoint(1)=-53.071796769724#: StartPoint(2)= 10#
	EndPoint(0)=181#: EndPoint(1)=-56.535898384862#: EndPoint(2)= 16#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid22(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=0#: transMat(0,1)=0#: transMat(0,2)=1#: transMat(0,3)=181#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=-60#
	transMat(2,0)=-1#: transMat(2,1)=0#: transMat(2,2)=0#: transMat(2,3)=10#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch29(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=14
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(-1,0,0)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch30(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	StartPoint(0)=181#: StartPoint(1)=-56.535898384862#: StartPoint(2)= 123#
	EndPoint(0)=181#: EndPoint(1)=-63.464101615138#: EndPoint(2)= 123#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=181#: StartPoint(1)=-63.464101615138#: StartPoint(2)= 123#
	EndPoint(0)=181#: EndPoint(1)=-66.928203230276#: EndPoint(2)= 117#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=181#: StartPoint(1)=-66.928203230276#: StartPoint(2)= 117#
	EndPoint(0)=181#: EndPoint(1)=-63.464101615138#: EndPoint(2)= 111#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=181#: StartPoint(1)=-63.464101615138#: StartPoint(2)= 111#
	EndPoint(0)=181#: EndPoint(1)=-56.535898384862#: EndPoint(2)= 111#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=181#: StartPoint(1)=-56.535898384862#: StartPoint(2)= 111#
	EndPoint(0)=181#: EndPoint(1)=-53.071796769724#: EndPoint(2)= 117#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=181#: StartPoint(1)=-53.071796769724#: StartPoint(2)= 117#
	EndPoint(0)=181#: EndPoint(1)=-56.535898384862#: EndPoint(2)= 123#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid23(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=0#: transMat(0,1)=0#: transMat(0,2)=1#: transMat(0,3)=181#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=-60#
	transMat(2,0)=-1#: transMat(2,1)=0#: transMat(2,2)=0#: transMat(2,3)=117#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch30(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=14
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(-1,0,0)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch31(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	StartPoint(0)=181#: StartPoint(1)=63.464101615138#: StartPoint(2)= 123#
	EndPoint(0)=181#: EndPoint(1)=56.535898384862#: EndPoint(2)= 123#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=181#: StartPoint(1)=56.535898384862#: StartPoint(2)= 123#
	EndPoint(0)=181#: EndPoint(1)=53.071796769724#: EndPoint(2)= 117#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=181#: StartPoint(1)=53.071796769724#: StartPoint(2)= 117#
	EndPoint(0)=181#: EndPoint(1)=56.535898384862#: EndPoint(2)= 111#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=181#: StartPoint(1)=56.535898384862#: StartPoint(2)= 111#
	EndPoint(0)=181#: EndPoint(1)=63.464101615138#: EndPoint(2)= 111#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=181#: StartPoint(1)=63.464101615138#: StartPoint(2)= 111#
	EndPoint(0)=181#: EndPoint(1)=66.928203230276#: EndPoint(2)= 117#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=181#: StartPoint(1)=66.928203230276#: StartPoint(2)= 117#
	EndPoint(0)=181#: EndPoint(1)=63.464101615138#: EndPoint(2)= 123#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid24(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=0#: transMat(0,1)=0#: transMat(0,2)=1#: transMat(0,3)=181#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=60#
	transMat(2,0)=-1#: transMat(2,1)=0#: transMat(2,2)=0#: transMat(2,3)=117#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch31(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=14
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(-1,0,0)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch32(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	StartPoint(0)=181#: StartPoint(1)=63.464101615138#: StartPoint(2)= 16#
	EndPoint(0)=181#: EndPoint(1)=56.535898384862#: EndPoint(2)= 16#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=181#: StartPoint(1)=56.535898384862#: StartPoint(2)= 16#
	EndPoint(0)=181#: EndPoint(1)=53.071796769724#: EndPoint(2)= 10#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=181#: StartPoint(1)=53.071796769724#: StartPoint(2)= 10#
	EndPoint(0)=181#: EndPoint(1)=56.535898384862#: EndPoint(2)= 4#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=181#: StartPoint(1)=56.535898384862#: StartPoint(2)= 4#
	EndPoint(0)=181#: EndPoint(1)=63.464101615138#: EndPoint(2)= 4#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=181#: StartPoint(1)=63.464101615138#: StartPoint(2)= 4#
	EndPoint(0)=181#: EndPoint(1)=66.928203230276#: EndPoint(2)= 10#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=181#: StartPoint(1)=66.928203230276#: StartPoint(2)= 10#
	EndPoint(0)=181#: EndPoint(1)=63.464101615138#: EndPoint(2)= 16#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid25(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=0#: transMat(0,1)=0#: transMat(0,2)=1#: transMat(0,3)=181#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=60#
	transMat(2,0)=-1#: transMat(2,1)=0#: transMat(2,2)=0#: transMat(2,3)=10#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch32(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=14
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(-1,0,0)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch33(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=70#: CenterPoint(1)=67#: CenterPoint(2)=0#
	Radius=51.5#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid26(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=0#: transMat(0,1)=0#: transMat(0,2)=-1#: transMat(0,3)=-82#
	transMat(1,0)=-1#: transMat(1,1)=0#: transMat(1,2)=0#: transMat(1,3)=70#
	transMat(2,0)=0#: transMat(2,1)=1#: transMat(2,2)=0#: transMat(2,3)=0#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch33(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=10
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(1,0,0)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch34(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=0#: CenterPoint(1)=0#: CenterPoint(2)=0#
	Radius=51.5#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid27(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=0#: transMat(0,1)=0#: transMat(0,2)=-1#: transMat(0,3)=-72#
	transMat(1,0)=-1#: transMat(1,1)=0#: transMat(1,2)=0#: transMat(1,3)=0#
	transMat(2,0)=0#: transMat(2,1)=1#: transMat(2,2)=0#: transMat(2,3)=67#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch34(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=10.1
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=1
	ExtrusionDescriptor.Direction=ge.Vector(-1,0,0)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch35(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	StartPoint(0)=-82.1#: StartPoint(1)=55#: StartPoint(2)= 14.5#
	EndPoint(0)=-82.1#: EndPoint(1)=-55#: EndPoint(2)= 14.5#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=-82.1#: StartPoint(1)=-55#: StartPoint(2)= 14.5#
	EndPoint(0)=-82.1#: EndPoint(1)=-55#: EndPoint(2)= 119.5#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=-82.1#: StartPoint(1)=-55#: StartPoint(2)= 119.5#
	EndPoint(0)=-82.1#: EndPoint(1)=55#: EndPoint(2)= 119.5#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=-82.1#: StartPoint(1)=55#: StartPoint(2)= 119.5#
	EndPoint(0)=-82.1#: EndPoint(1)=55#: EndPoint(2)= 14.5#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid28(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=0#: transMat(0,1)=0#: transMat(0,2)=-1#: transMat(0,3)=-82.1#
	transMat(1,0)=-1#: transMat(1,1)=0#: transMat(1,2)=0#: transMat(1,3)=0#
	transMat(2,0)=0#: transMat(2,1)=1#: transMat(2,2)=0#: transMat(2,3)=67#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch35(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=27
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=1
	ExtrusionDescriptor.Direction=ge.Vector(-1,0,0)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch36(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=171#: CenterPoint(1)=0#: CenterPoint(2)=0#
	Radius=6#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid29(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=1#: transMat(0,1)=0#: transMat(0,2)=0#: transMat(0,3)=0#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=0#
	transMat(2,0)=0#: transMat(2,1)=0#: transMat(2,2)=1#: transMat(2,3)=127#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch36(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=2
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=1
	ExtrusionDescriptor.Direction=ge.Vector(0,0,1)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch37(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	StartPoint(0)=166.5#: StartPoint(1)=1.7763568394003e-015#: StartPoint(2)= 129#
	EndPoint(0)=167.10288568297#: EndPoint(1)=-2.25#: EndPoint(2)= 129#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=167.10288568297#: StartPoint(1)=-2.25#: StartPoint(2)= 129#
	EndPoint(0)=168.75#: EndPoint(1)=-3.89711431703#: EndPoint(2)= 129#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=168.75#: StartPoint(1)=-3.89711431703#: StartPoint(2)= 129#
	EndPoint(0)=171#: EndPoint(1)=-4.5#: EndPoint(2)= 129#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=171#: StartPoint(1)=-4.5#: StartPoint(2)= 129#
	EndPoint(0)=173.25#: EndPoint(1)=-3.89711431703#: EndPoint(2)= 129#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=173.25#: StartPoint(1)=-3.89711431703#: StartPoint(2)= 129#
	EndPoint(0)=174.89711431703#: EndPoint(1)=-2.25#: EndPoint(2)= 129#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=174.89711431703#: StartPoint(1)=-2.25#: StartPoint(2)= 129#
	EndPoint(0)=175.5#: EndPoint(1)=-8.8817841970013e-016#: EndPoint(2)= 129#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=175.5#: StartPoint(1)=-8.8817841970013e-016#: StartPoint(2)= 129#
	EndPoint(0)=174.89711431703#: EndPoint(1)=2.25#: EndPoint(2)= 129#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=174.89711431703#: StartPoint(1)=2.25#: StartPoint(2)= 129#
	EndPoint(0)=173.25#: EndPoint(1)=3.89711431703#: EndPoint(2)= 129#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=173.25#: StartPoint(1)=3.89711431703#: StartPoint(2)= 129#
	EndPoint(0)=171#: EndPoint(1)=4.5#: EndPoint(2)= 129#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=171#: StartPoint(1)=4.5#: StartPoint(2)= 129#
	EndPoint(0)=168.75#: EndPoint(1)=3.89711431703#: EndPoint(2)= 129#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=168.75#: StartPoint(1)=3.89711431703#: StartPoint(2)= 129#
	EndPoint(0)=167.10288568297#: EndPoint(1)=2.25#: EndPoint(2)= 129#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=167.10288568297#: StartPoint(1)=2.25#: StartPoint(2)= 129#
	EndPoint(0)=166.5#: EndPoint(1)=1.7763568394003e-015#: EndPoint(2)= 129#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid30(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=1#: transMat(0,1)=0#: transMat(0,2)=0#: transMat(0,3)=171#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=0#
	transMat(2,0)=0#: transMat(2,1)=0#: transMat(2,2)=1#: transMat(2,3)=129#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch37(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=0.5
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(0,0,-1)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch38(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	StartPoint(0)=169#: StartPoint(1)=1.1547005383793#: StartPoint(2)= 129#
	EndPoint(0)=169#: EndPoint(1)=-1.1547005383793#: EndPoint(2)= 129#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=169#: StartPoint(1)=-1.1547005383793#: StartPoint(2)= 129#
	EndPoint(0)=171#: EndPoint(1)=-2.3094010767585#: EndPoint(2)= 129#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=171#: StartPoint(1)=-2.3094010767585#: StartPoint(2)= 129#
	EndPoint(0)=173#: EndPoint(1)=-1.1547005383793#: EndPoint(2)= 129#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=173#: StartPoint(1)=-1.1547005383793#: StartPoint(2)= 129#
	EndPoint(0)=173#: EndPoint(1)=1.1547005383793#: EndPoint(2)= 129#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=173#: StartPoint(1)=1.1547005383793#: StartPoint(2)= 129#
	EndPoint(0)=171#: EndPoint(1)=2.3094010767585#: EndPoint(2)= 129#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=171#: StartPoint(1)=2.3094010767585#: StartPoint(2)= 129#
	EndPoint(0)=169#: EndPoint(1)=1.1547005383793#: EndPoint(2)= 129#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid31(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=1#: transMat(0,1)=0#: transMat(0,2)=0#: transMat(0,3)=171#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=0#
	transMat(2,0)=0#: transMat(2,1)=0#: transMat(2,2)=1#: transMat(2,3)=129#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch38(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=1
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(0,0,-1)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch39(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=25#: CenterPoint(1)=6#: CenterPoint(2)=0#
	Radius=2.5#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid32(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=0#: transMat(0,1)=1#: transMat(0,2)=0#: transMat(0,3)=-1.8498821867886e-017#
	transMat(1,0)=-1#: transMat(1,1)=0#: transMat(1,2)=0#: transMat(1,3)=69.9#
	transMat(2,0)=0#: transMat(2,1)=0#: transMat(2,2)=1#: transMat(2,3)=126.9#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch39(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=0.5
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(0,0,-1)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch40(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=115#: CenterPoint(1)=6#: CenterPoint(2)=0#
	Radius=2.5#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid33(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=0#: transMat(0,1)=1#: transMat(0,2)=0#: transMat(0,3)=-1.8498821867886e-017#
	transMat(1,0)=-1#: transMat(1,1)=0#: transMat(1,2)=0#: transMat(1,3)=69.9#
	transMat(2,0)=0#: transMat(2,1)=0#: transMat(2,2)=1#: transMat(2,3)=126.9#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch40(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=0.5
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(0,0,-1)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch41(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=55#: CenterPoint(1)=85.25#: CenterPoint(2)=0#
	Radius=9#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid34(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=0#: transMat(0,1)=0#: transMat(0,2)=-1#: transMat(0,3)=-109.1#
	transMat(1,0)=-1#: transMat(1,1)=0#: transMat(1,2)=0#: transMat(1,3)=55#
	transMat(2,0)=0#: transMat(2,1)=1#: transMat(2,2)=0#: transMat(2,3)=14.5#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch41(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=0.2
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(1,0,0)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch42(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=55#: CenterPoint(1)=19.75#: CenterPoint(2)=0#
	Radius=9#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid35(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=0#: transMat(0,1)=0#: transMat(0,2)=-1#: transMat(0,3)=-109.1#
	transMat(1,0)=-1#: transMat(1,1)=0#: transMat(1,2)=0#: transMat(1,3)=55#
	transMat(2,0)=0#: transMat(2,1)=1#: transMat(2,2)=0#: transMat(2,3)=14.5#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch42(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=0.2
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(1,0,0)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch43(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=22.25#: CenterPoint(1)=52.5#: CenterPoint(2)=0#
	Radius=6#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid36(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=0#: transMat(0,1)=0#: transMat(0,2)=-1#: transMat(0,3)=-109.1#
	transMat(1,0)=-1#: transMat(1,1)=0#: transMat(1,2)=0#: transMat(1,3)=55#
	transMat(2,0)=0#: transMat(2,1)=1#: transMat(2,2)=0#: transMat(2,3)=14.5#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch43(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=6
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(1,0,0)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch44(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=87.75#: CenterPoint(1)=52.5#: CenterPoint(2)=0#
	Radius=6#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid37(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=0#: transMat(0,1)=0#: transMat(0,2)=-1#: transMat(0,3)=-109.1#
	transMat(1,0)=-1#: transMat(1,1)=0#: transMat(1,2)=0#: transMat(1,3)=55#
	transMat(2,0)=0#: transMat(2,1)=1#: transMat(2,2)=0#: transMat(2,3)=14.5#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch44(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=6
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(1,0,0)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch45(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	StartPoint(0)=-108.9#: StartPoint(1)=3#: StartPoint(2)= 101.48205080757#
	EndPoint(0)=-108.9#: EndPoint(1)=3#: EndPoint(2)= 98.017949192431#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=-108.9#: StartPoint(1)=3#: StartPoint(2)= 98.017949192431#
	EndPoint(0)=-108.9#: EndPoint(1)=0#: EndPoint(2)= 96.285898384862#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=-108.9#: StartPoint(1)=0#: StartPoint(2)= 96.285898384862#
	EndPoint(0)=-108.9#: EndPoint(1)=-3#: EndPoint(2)= 98.017949192431#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=-108.9#: StartPoint(1)=-3#: StartPoint(2)= 98.017949192431#
	EndPoint(0)=-108.9#: EndPoint(1)=-3#: EndPoint(2)= 101.48205080757#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=-108.9#: StartPoint(1)=-3#: StartPoint(2)= 101.48205080757#
	EndPoint(0)=-108.9#: EndPoint(1)=0#: EndPoint(2)= 103.21410161514#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=-108.9#: StartPoint(1)=0#: StartPoint(2)= 103.21410161514#
	EndPoint(0)=-108.9#: EndPoint(1)=3#: EndPoint(2)= 101.48205080757#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid38(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=0#: transMat(0,1)=0#: transMat(0,2)=-1#: transMat(0,3)=-108.9#
	transMat(1,0)=-1#: transMat(1,1)=0#: transMat(1,2)=0#: transMat(1,3)=0#
	transMat(2,0)=0#: transMat(2,1)=1#: transMat(2,2)=0#: transMat(2,3)=99.75#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch45(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=4
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(1,0,0)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch46(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	StartPoint(0)=-108.9#: StartPoint(1)=3#: StartPoint(2)= 35.982050807569#
	EndPoint(0)=-108.9#: EndPoint(1)=3#: EndPoint(2)= 32.517949192431#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=-108.9#: StartPoint(1)=3#: StartPoint(2)= 32.517949192431#
	EndPoint(0)=-108.9#: EndPoint(1)=0#: EndPoint(2)= 30.785898384862#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=-108.9#: StartPoint(1)=0#: StartPoint(2)= 30.785898384862#
	EndPoint(0)=-108.9#: EndPoint(1)=-3#: EndPoint(2)= 32.517949192431#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=-108.9#: StartPoint(1)=-3#: StartPoint(2)= 32.517949192431#
	EndPoint(0)=-108.9#: EndPoint(1)=-3#: EndPoint(2)= 35.982050807569#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=-108.9#: StartPoint(1)=-3#: StartPoint(2)= 35.982050807569#
	EndPoint(0)=-108.9#: EndPoint(1)=0#: EndPoint(2)= 37.714101615138#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=-108.9#: StartPoint(1)=0#: StartPoint(2)= 37.714101615138#
	EndPoint(0)=-108.9#: EndPoint(1)=3#: EndPoint(2)= 35.982050807569#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid39(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=0#: transMat(0,1)=0#: transMat(0,2)=-1#: transMat(0,3)=-108.9#
	transMat(1,0)=-1#: transMat(1,1)=0#: transMat(1,2)=0#: transMat(1,3)=0#
	transMat(2,0)=0#: transMat(2,1)=1#: transMat(2,2)=0#: transMat(2,3)=34.25#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch46(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=4
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(1,0,0)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch47(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=0#: CenterPoint(1)=0#: CenterPoint(2)=0#
	Radius=5#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid40(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=0#: transMat(0,1)=0#: transMat(0,2)=-1#: transMat(0,3)=-103.1#
	transMat(1,0)=-1#: transMat(1,1)=0#: transMat(1,2)=0#: transMat(1,3)=-32.75#
	transMat(2,0)=0#: transMat(2,1)=1#: transMat(2,2)=0#: transMat(2,3)=67#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch47(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=8
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(1,0,0)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch48(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=0#: CenterPoint(1)=0#: CenterPoint(2)=0#
	Radius=5#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid41(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=0#: transMat(0,1)=0#: transMat(0,2)=-1#: transMat(0,3)=-103.1#
	transMat(1,0)=-1#: transMat(1,1)=0#: transMat(1,2)=0#: transMat(1,3)=32.75#
	transMat(2,0)=0#: transMat(2,1)=1#: transMat(2,2)=0#: transMat(2,3)=67#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch48(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=8
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(1,0,0)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch49(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=25#: CenterPoint(1)=67#: CenterPoint(2)=0#
	Radius=6#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid42(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=1#: transMat(0,1)=0#: transMat(0,2)=0#: transMat(0,3)=-82#
	transMat(1,0)=0#: transMat(1,1)=0#: transMat(1,2)=-1#: transMat(1,3)=-70#
	transMat(2,0)=0#: transMat(2,1)=1#: transMat(2,2)=0#: transMat(2,3)=0#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch49(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=1
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(0,1,0)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch50(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=67#: CenterPoint(1)=25#: CenterPoint(2)=0#
	Radius=6#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid43(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=0#: transMat(0,1)=1#: transMat(0,2)=0#: transMat(0,3)=-82#
	transMat(1,0)=0#: transMat(1,1)=0#: transMat(1,2)=1#: transMat(1,3)=70#
	transMat(2,0)=1#: transMat(2,1)=0#: transMat(2,2)=0#: transMat(2,3)=0#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch50(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=1
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=2
	ExtrusionDescriptor.Direction=ge.Vector(0,-1,0)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch51(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=-4.4721286549613#: CenterPoint(1)=-0.50000739815066#: CenterPoint(2)=0#
	StartAngle=1.5708109266554#
	EndAngle=4.685673843797#
	Radius=0.50000739820395#
	Set EntObj=createArc(CenterPoint,StartAngle,EndAngle,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=-57.999836379696#: StartPoint(1)=69#: StartPoint(2)= 62.514515167947#
	EndPoint(0)=-58.002468733157#: EndPoint(1)=69#: EndPoint(2)= 62.613081213535#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	CenterPoint(0)=-4.4497190922574#: CenterPoint(1)=-1.8#: CenterPoint(2)=0#
	StartAngle=0.38439677449564#
	EndAngle=1.4922150962094#
	Radius=0.8#
	Set EntObj=createArc(CenterPoint,StartAngle,EndAngle,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	CenterPoint(0)=1.1102230246252e-016#: CenterPoint(1)=9.9920072216264e-016#: CenterPoint(2)=0#
	StartAngle=3.5259894280854#
	EndAngle=2.6444869389638#
	Radius=4#
	Set EntObj=createArc(CenterPoint,StartAngle,EndAngle,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	CenterPoint(0)=-4.2190390971582#: CenterPoint(1)=2.2890410867109#: CenterPoint(2)=0#
	StartAngle=4.5824520235206#
	EndAngle=5.7860795925536#
	Radius=0.8#
	Set EntObj=createArc(CenterPoint,StartAngle,EndAngle,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	CenterPoint(0)=-4.3874821936961#: CenterPoint(1)=1#: CenterPoint(2)=0#
	StartAngle=1.4408594183596#
	EndAngle=4.5438800613642#
	Radius=0.5#
	Set EntObj=createArc(CenterPoint,StartAngle,EndAngle,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=-56.492917967881#: StartPoint(1)=69#: StartPoint(2)= 62.528661518885#
	EndPoint(0)=-56.492917967881#: EndPoint(1)=69#: EndPoint(2)= 63.536927980434#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	CenterPoint(0)=3.9898639947467e-017#: CenterPoint(1)=0#: CenterPoint(2)=0#
	StartAngle=3.1415926535898#
	EndAngle=2.9962003749587#
	Radius=3.5#
	Set EntObj=createArc(CenterPoint,StartAngle,EndAngle,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=-57#: StartPoint(1)=69#: StartPoint(2)= 63.5#
	EndPoint(0)=-57#: EndPoint(1)=69#: EndPoint(2)= 62.527864045#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSketch52(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=-4.3874821936961#: CenterPoint(1)=1#: CenterPoint(2)=0#
	Radius=0.3#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSketch53(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=-4.4721359549996#: CenterPoint(1)=-0.5#: CenterPoint(2)=0#
	Radius=0.3#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid44(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=0#: transMat(0,1)=1#: transMat(0,2)=0#: transMat(0,3)=-57#
	transMat(1,0)=0#: transMat(1,1)=0#: transMat(1,2)=1#: transMat(1,3)=69#
	transMat(2,0)=1#: transMat(2,1)=0#: transMat(2,2)=0#: transMat(2,3)=67#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch51(transMat)
	call CreateSketch52(transMat)
	call CreateSketch53(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=0.5
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=1
	ExtrusionDescriptor.Direction=ge.Vector(0,1,0)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch54(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=0#: CenterPoint(1)=0#: CenterPoint(2)=0#
	Radius=3.5#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid45(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=0#: transMat(0,1)=1#: transMat(0,2)=0#: transMat(0,3)=-57#
	transMat(1,0)=0#: transMat(1,1)=0#: transMat(1,2)=1#: transMat(1,3)=69#
	transMat(2,0)=1#: transMat(2,1)=0#: transMat(2,2)=0#: transMat(2,3)=67#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch54(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=1
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=1
	ExtrusionDescriptor.Direction=ge.Vector(0,1,0)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch55(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=-4.4721286549613#: CenterPoint(1)=-0.50000739815066#: CenterPoint(2)=0#
	StartAngle=1.5708109266554#
	EndAngle=4.685673843797#
	Radius=0.50000739820395#
	Set EntObj=createArc(CenterPoint,StartAngle,EndAngle,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=-61.485484832053#: StartPoint(1)=-69#: StartPoint(2)= 66.000163620304#
	EndPoint(0)=-61.386918786465#: EndPoint(1)=-69#: EndPoint(2)= 65.997531266843#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	CenterPoint(0)=-4.4497190922574#: CenterPoint(1)=-1.8#: CenterPoint(2)=0#
	StartAngle=0.38439677449564#
	EndAngle=1.4922150962094#
	Radius=0.8#
	Set EntObj=createArc(CenterPoint,StartAngle,EndAngle,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	CenterPoint(0)=1.1102230246252e-016#: CenterPoint(1)=9.9920072216264e-016#: CenterPoint(2)=0#
	StartAngle=3.5259894280854#
	EndAngle=2.6444869389638#
	Radius=4#
	Set EntObj=createArc(CenterPoint,StartAngle,EndAngle,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	CenterPoint(0)=-4.2190390971582#: CenterPoint(1)=2.2890410867109#: CenterPoint(2)=0#
	StartAngle=4.5824520235206#
	EndAngle=5.7860795925536#
	Radius=0.8#
	Set EntObj=createArc(CenterPoint,StartAngle,EndAngle,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	CenterPoint(0)=-4.3874821936961#: CenterPoint(1)=1#: CenterPoint(2)=0#
	StartAngle=1.4408594183596#
	EndAngle=4.5438800613642#
	Radius=0.5#
	Set EntObj=createArc(CenterPoint,StartAngle,EndAngle,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=-61.471338481115#: StartPoint(1)=-69#: StartPoint(2)= 67.507082032119#
	EndPoint(0)=-60.463072019566#: EndPoint(1)=-69#: EndPoint(2)= 67.507082032119#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	CenterPoint(0)=3.9898639947467e-017#: CenterPoint(1)=0#: CenterPoint(2)=0#
	StartAngle=3.1415926535898#
	EndAngle=2.9962003749587#
	Radius=3.5#
	Set EntObj=createArc(CenterPoint,StartAngle,EndAngle,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
	StartPoint(0)=-60.5#: StartPoint(1)=-69#: StartPoint(2)= 67#
	EndPoint(0)=-61.472135955#: EndPoint(1)=-69#: EndPoint(2)= 67#
	Set EntObj=createLine(StartPoint,EndPoint)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSketch56(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=-4.3874821936961#: CenterPoint(1)=1#: CenterPoint(2)=0#
	Radius=0.3#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSketch57(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=-4.4721359549996#: CenterPoint(1)=-0.5#: CenterPoint(2)=0#
	Radius=0.3#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid46(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=1#: transMat(0,1)=0#: transMat(0,2)=0#: transMat(0,3)=-57#
	transMat(1,0)=0#: transMat(1,1)=0#: transMat(1,2)=-1#: transMat(1,3)=-69#
	transMat(2,0)=0#: transMat(2,1)=1#: transMat(2,2)=0#: transMat(2,3)=67#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch55(transMat)
	call CreateSketch56(transMat)
	call CreateSketch57(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=0.5
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=1
	ExtrusionDescriptor.Direction=ge.Vector(0,-1,0)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function

function CreateSketch58(transMat)
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	CenterPoint(0)=0#: CenterPoint(1)=0#: CenterPoint(2)=0#
	Radius=3.5#
	Set EntObj=createCircle(CenterPoint,Radius,transMat)
	EntityDic.add cstr(Count),EntObj 
	Count=Count+1
End function

function CreateSolid47(MCad As Object,Util As Object,Ge As Object,Part As Object,Instance As Object)
	Dim SketchPlane As Object
	Dim Val As Object
	Dim BlindTerminator As Object
	Dim RevolveDesc As Object
	Dim RevolveFeat As Object
	Dim ExtrusionDescriptor As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim CenterPoint(0 To 2) As Double
	Dim StartPoint(0 To 2) As Double
	Dim EndPoint(0 To 2) As Double
	Dim CenterLine As Object
	transMat(0,0)=1#: transMat(0,1)=0#: transMat(0,2)=0#: transMat(0,3)=-57#
	transMat(1,0)=0#: transMat(1,1)=0#: transMat(1,2)=-1#: transMat(1,3)=-69#
	transMat(2,0)=0#: transMat(2,1)=1#: transMat(2,2)=0#: transMat(2,3)=67#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Count=0
	EntityDic.RemoveAll
	call CreateSketch58(transMat)
	Set SketchPlane=createSketchPlane(transMat,Util,Ge,Part)
	Set Sketch= createProfile(Part,Util,SketchPlane,Instance)
	Set Val=Util.CreateValue
	Val=1
	Set BlindTerminator=Util.CreateTerminator(0)
	BlindTerminator.Distance=Val
	Set ExtrusionDescriptor=Util.CreateFeatureDescriptor(4)
	ExtrusionDescriptor.CombineType=1
	ExtrusionDescriptor.Direction=ge.Vector(0,-1,0)
	ExtrusionDescriptor.Profile=Sketch
	ExtrusionDescriptor.Terminator=BlindTerminator
	Set Extrusion=Part.AddFeature(ExtrusionDescriptor)
end function


sub CreatePart0(MCad As Object,Util As Object,Ge As Object,PathName)
	Dim Part As Object
	Set EntityDic = CreateObject("Scripting.Dictionary")
	Dim Instance As Object
	Dim transMat(0 To 3, 0 To 3) As Double
	Dim ParentAssembly As Object
	Dim Definition As Object
	transMat(0,0)=1#: transMat(0,1)=0#: transMat(0,2)=0#: transMat(0,3)=0#
	transMat(1,0)=0#: transMat(1,1)=1#: transMat(1,2)=0#: transMat(1,3)=0#
	transMat(2,0)=0#: transMat(2,1)=0#: transMat(2,2)=1#: transMat(2,3)=0#
	transMat(3,0)=0#: transMat(3,1)=0#: transMat(3,2)=0#: transMat(3,3)=1#
	Set PartMatrix=Ge.Matrix
	PartMatrix.AsArray=transMat
	Set ParentAssembly=MCad.ActiveDocument.AssemblyMgr.ActiveDefinition
	FileName=PathName+"\SN5600A1200025PL1SX0.dwg"
	if(existsFile(FileName)=1)then
		Set Definition=MCad.ActiveDocument.AssemblyMgr.AddCompDefFromFile(FileName,"SN5600A1200025PL1SX0")
		Set Component=MCad.ActiveDocument.assemblyMgr.ActiveDefinition.AddComponent(Definition, PartMatrix)
	else
		Set Part=MCad.ActiveDocument.AddNewPart("SN5600A1200025PL1SX0")
		Set Instance=MCad.ActiveDocument.AssemblyMgr.ActiveInstance
		call CreateSolid0(MCad,Util,Ge,Part,Instance)
		call CreateSolid1(MCad,Util,Ge,Part,Instance)
		call CreateSolid2(MCad,Util,Ge,Part,Instance)
		call CreateSolid3(MCad,Util,Ge,Part,Instance)
		call CreateSolid4(MCad,Util,Ge,Part,Instance)
		call CreateSolid5(MCad,Util,Ge,Part,Instance)
		call CreateSolid6(MCad,Util,Ge,Part,Instance)
		call CreateSolid7(MCad,Util,Ge,Part,Instance)
		call CreateSolid8(MCad,Util,Ge,Part,Instance)
		call CreateSolid9(MCad,Util,Ge,Part,Instance)
		call CreateSolid10(MCad,Util,Ge,Part,Instance)
		call CreateSolid11(MCad,Util,Ge,Part,Instance)
		call CreateSolid12(MCad,Util,Ge,Part,Instance)
		call CreateSolid13(MCad,Util,Ge,Part,Instance)
		call CreateSolid14(MCad,Util,Ge,Part,Instance)
		call CreateSolid15(MCad,Util,Ge,Part,Instance)
		call CreateSolid16(MCad,Util,Ge,Part,Instance)
		call CreateSolid17(MCad,Util,Ge,Part,Instance)
		call CreateSolid18(MCad,Util,Ge,Part,Instance)
		call CreateSolid19(MCad,Util,Ge,Part,Instance)
		call CreateSolid20(MCad,Util,Ge,Part,Instance)
		call CreateSolid21(MCad,Util,Ge,Part,Instance)
		call CreateSolid22(MCad,Util,Ge,Part,Instance)
		call CreateSolid23(MCad,Util,Ge,Part,Instance)
		call CreateSolid24(MCad,Util,Ge,Part,Instance)
		call CreateSolid25(MCad,Util,Ge,Part,Instance)
		call CreateSolid26(MCad,Util,Ge,Part,Instance)
		call CreateSolid27(MCad,Util,Ge,Part,Instance)
		call CreateSolid28(MCad,Util,Ge,Part,Instance)
		call CreateSolid29(MCad,Util,Ge,Part,Instance)
		call CreateSolid30(MCad,Util,Ge,Part,Instance)
		call CreateSolid31(MCad,Util,Ge,Part,Instance)
		call CreateSolid32(MCad,Util,Ge,Part,Instance)
		call CreateSolid33(MCad,Util,Ge,Part,Instance)
		call CreateSolid34(MCad,Util,Ge,Part,Instance)
		call CreateSolid35(MCad,Util,Ge,Part,Instance)
		call CreateSolid36(MCad,Util,Ge,Part,Instance)
		call CreateSolid37(MCad,Util,Ge,Part,Instance)
		call CreateSolid38(MCad,Util,Ge,Part,Instance)
		call CreateSolid39(MCad,Util,Ge,Part,Instance)
		call CreateSolid40(MCad,Util,Ge,Part,Instance)
		call CreateSolid41(MCad,Util,Ge,Part,Instance)
		call CreateSolid42(MCad,Util,Ge,Part,Instance)
		call CreateSolid43(MCad,Util,Ge,Part,Instance)
		call CreateSolid44(MCad,Util,Ge,Part,Instance)
		call CreateSolid45(MCad,Util,Ge,Part,Instance)
		call CreateSolid46(MCad,Util,Ge,Part,Instance)
		call CreateSolid47(MCad,Util,Ge,Part,Instance)
		Part.Definition.Externalize FileName
		Instance.Position=PartMatrix
	end if
	MCad.ActiveDocument.AssemblyMgr.ActiveDefinition=ParentAssembly
end sub

Sub Main()

	ThisDrawing.SendCommand "AMSKMODE" & vbCr & "0" & vbCr
	PathName=StoreWindow
	if(PathName<>"")then
		Dim MCad As Object
		Set MCad=ThisDrawing.Application.GetInterfaceObject("Mcad.Application")
		Dim Util As Object
		Set Util=MCad.ActiveDocument.Utility
		Dim Ge As Object
		Set Ge=ThisDrawing.Application.GetInterfaceObject("Ge.Application")
		setxyUCS
		call CreatePart0(MCad,Util,Ge,PathName)
	end if

end sub

